package com.s5gi.giGuns;

import com.s5gi.giGuns.guns.BulletType;
import com.s5gi.giGuns.guns.GunHandler;
import com.s5gi.giGuns.guns.Guns;
import com.s5gi.giGuns.guns.IGun;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.World;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.entity.Snowball;
import org.bukkit.event.block.Action;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

public final class giGuns extends JavaPlugin {

    public static JavaPlugin plugin;

    public static String color(String i) {return ChatColor.translateAlternateColorCodes('&', i);}


    @Override
    public void onEnable() {
        // Plugin startup logic
        plugin = this;

        //CLEANUP
        for (World world : Bukkit.getWorlds()) {
            for (Entity entity : world.getEntities()) {
                if (entity instanceof Snowball snowball) {
                    if (snowball.hasMetadata("isBullet")) snowball.remove();
                }
            }
        }
        ///CLEANUP

        BulletType.init();
        Guns.init();
        getServer().getPluginManager().registerEvents(new GunHandler(), this);

        getServer().getScheduler().scheduleSyncRepeatingTask(this, GunHandler::BulletRoutine, 0, 1);
        getServer().getScheduler().scheduleSyncRepeatingTask(this, GunHandler::BulletTrailRoutine, 0, 3);


        getCommand("getgun").setExecutor((commandSender, command, s, args) -> {
            if (commandSender instanceof Player player) {
                IGun gun = GunHandler.guns.get(Integer.parseInt(args[0]));
                player.getInventory().addItem(gun.compileGun());
            }
            return false;
        });
        getCommand("getammo").setExecutor((commandSender, command, s, args) -> {
            if (commandSender instanceof Player player) {
                if (player.getInventory().getItemInMainHand() !=null &&
                        player.getInventory().getItemInMainHand().getItemMeta()!=null  &&
                        GunHandler.isRegisteredGun(player.getInventory().getItemInMainHand().getItemMeta().getItemName())) {
                    IGun gun = GunHandler.getRegisteredGun(player.getInventory().getItemInMainHand().getItemMeta().getItemName());
                    ItemStack ammo = gun.bulletType().getItem();
                    ammo.setAmount(64);
                    player.getInventory().addItem(ammo);
                }
            }
            return false;
        });
    }

    @Override
    public void onDisable() {
        GunHandler.physicsBullets.keySet().forEach(physbullet -> {
            physbullet.remove();
        });
    }
}
