package com.s5gi.giGuns.guns.ind;

import com.s5gi.giGuns.guns.BulletType;
import com.s5gi.giGuns.guns.IGun;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.Sound;
import org.bukkit.block.Block;
import org.bukkit.entity.LivingEntity;
import org.bukkit.inventory.CraftingRecipe;
import org.bukkit.inventory.ShapedRecipe;

import java.util.List;

public class AK47 implements IGun {
    @Override
    public String name() {
        return "&cAK-47";
    }

    @Override
    public int textureId() {
        return 2;
    }

    @Override
    public List<String> description() {
        return List.of("&cSoviet &eUnion", "&7A gas-operated, long-stroke piston, closed rotating bolt, assault rifle");
    }

    @Override
    public BulletType bulletType() {
        return BulletType.RIFLE;
    }

    @Override
    public List<Sound> sound() {
        return List.of(Sound.ENTITY_FIREWORK_ROCKET_BLAST);
    }

    @Override
    public float soundPitch() {
        return 0.8f;
    }

    @Override
    public void onHitEntity(Location location, LivingEntity entity) {

    }

    @Override
    public void onHitBlock(Location location, Block block) {

    }

    @Override
    public double bulletSpeed() {
        return 3.4;
    }

    @Override
    public double damage() {
        return 6;
    }

    @Override
    public boolean gravity() {
        return true;
    }

    @Override
    public int cooldown() {
        return 4;
    }

    @Override
    public CraftingRecipe recipe() {
        ShapedRecipe recipe = new ShapedRecipe(NamespacedKey.fromString("giguns:ak47"), compileGun());
        recipe.shape("iii","rdI","iis");
        recipe.setIngredient('i', Material.IRON_INGOT);
        recipe.setIngredient('I', Material.IRON_BLOCK);
        recipe.setIngredient('r', Material.BLAZE_ROD);
        recipe.setIngredient('d', Material.DISPENSER);
        recipe.setIngredient('s', Material.STICK);
        return recipe;
    }
}
