package com.s5gi.giGuns.guns.ind;

import com.s5gi.giGuns.giGuns;
import com.s5gi.giGuns.guns.BulletType;
import com.s5gi.giGuns.guns.IGun;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.Sound;
import org.bukkit.block.Block;
import org.bukkit.entity.LivingEntity;
import org.bukkit.inventory.CraftingRecipe;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.ShapedRecipe;
import org.bukkit.inventory.meta.CrossbowMeta;
import org.bukkit.inventory.meta.components.CustomModelDataComponent;

import java.util.List;

public class barrettM82 implements IGun {
    @Override
    public String name() {
        return "&cBarrett M82";
    }

    @Override
    public List<String> description() {
        return List.of("&9U.S.A.","&7A recoil-operated, semi-automatic anti-tank rifle");
    }

    @Override
    public int textureId() {
        return 4;
    }

    @Override
    public BulletType bulletType() {
        return BulletType.ANTI_TANK;
    }

    @Override
    public List<Sound> sound() {
        return List.of(Sound.ENTITY_FIREWORK_ROCKET_BLAST);
    }

    @Override
    public float soundPitch() {
        return 0.5f;
    }

    @Override
    public void onHitEntity(Location location, LivingEntity entity) {

    }

    @Override
    public void onHitBlock(Location location, Block block) {

    }

    @Override
    public double bulletSpeed() {
        return 4;
    }

    @Override
    public double damage() {
        return 14;
    }

    @Override
    public int cooldown() {
        return 40;
    }

    @Override
    public CraftingRecipe recipe() {
        ShapedRecipe recipe = new ShapedRecipe(NamespacedKey.fromString("giguns:barettm82"), compileGun());
        recipe.shape("Iii", "rRd", "Iis");
        recipe.setIngredient('i', Material.IRON_INGOT);
        recipe.setIngredient('I', Material.IRON_BLOCK);
        recipe.setIngredient('r', Material.BREEZE_ROD);
        recipe.setIngredient('R', Material.BLAZE_ROD);
        recipe.setIngredient('d', Material.DISPENSER);
        recipe.setIngredient('s', Material.STICK);
        return recipe;
    }
}
