package com.s5gi.giGuns.guns.ind;

import com.s5gi.giGuns.guns.BulletType;
import com.s5gi.giGuns.guns.GunHandler;
import com.s5gi.giGuns.guns.IGun;
import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.inventory.CraftingRecipe;
import org.bukkit.inventory.ShapedRecipe;
import org.bukkit.util.Vector;

import java.util.List;

public class m1Bazooka implements IGun {
    @Override
    public String name() {
        return "&4M1 Bazooka";
    }

    @Override
    public List<String> description() {
        return List.of("&9U.S.A.", "&7A man-portable recoilless anti-tank rocket launcher");
    }

    @Override
    public BulletType bulletType() {
        return BulletType.ANTI_TANK;
    }

    @Override
    public List<Sound> sound() {
        return List.of(Sound.ENTITY_GENERIC_EXPLODE, Sound.ENTITY_FIREWORK_ROCKET_BLAST);
    }

    @Override
    public float soundPitch() {
        return 0.55f;
    }

    @Override
    public void onHitEntity(Location location, LivingEntity entity) {
        explode(location);
    }

    @Override
    public void onHitBlock(Location location, Block block) {
        explode(location);
    }

    private static void explode(Location location) {
        //location.getWorld().createExplosion(location, 1f, false, false);
        for (Entity entity : location.getWorld().getNearbyEntities(location, 5f, 5f, 5f)) {

            if (entity instanceof LivingEntity livingEntity) {
                if (entity instanceof Player player) {
                    player.damage(4f - GunHandler.Calc.getDamageAfterArmor(player));
                } else {
                    livingEntity.damage(4f);
                }
                Location playerLocation = livingEntity.getLocation();

                // Calculate direction vector (from point to player)
                Vector direction = playerLocation.toVector().subtract(location.toVector());

                // Normalize the vector to keep consistent speed
                direction.normalize().multiply(1); // Change the multiplier for speed adjustments

                // Apply velocity to the player
                livingEntity.setVelocity(livingEntity.getVelocity().add(direction));
            }
        }
        location.getWorld().spawnParticle(Particle.EXPLOSION, location, 10, 0.1f, 0.1f, 0.1f);
    }

    @Override
    public double bulletSpeed() {
        return 2.8;
    }

    @Override
    public double damage() {
        return 18;
    }

    @Override
    public int cooldown() {
        return 200;
    }

    @Override
    public int textureId() {
        return 5;
    }

    @Override
    public CraftingRecipe recipe() {
        ShapedRecipe recipe = new ShapedRecipe(NamespacedKey.fromString("giguns:m1_bazooka"), compileGun());
        recipe.shape("III","rgT","IIs");
        recipe.setIngredient('T', Material.TNT);
        recipe.setIngredient('I', Material.IRON_BLOCK);
        recipe.setIngredient('r', Material.BLAZE_ROD);
        recipe.setIngredient('s', Material.STICK);
        recipe.setIngredient('g', Material.GUNPOWDER);
        return recipe;
    }
}
