package com.s5gi.giGuns.guns.ind;

import com.s5gi.giGuns.guns.BulletType;
import com.s5gi.giGuns.guns.IGun;
import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.inventory.CraftingRecipe;
import org.bukkit.inventory.ShapedRecipe;
import org.bukkit.util.Vector;

import java.util.List;

public class rocketJumper implements IGun {
    @Override
    public String name() {
        return "&6Rocket Jumper";
    }

    @Override
    public List<String> description() {
        return List.of("&6Fictional", "&6Rocket jump like your a tf2 player...");
    }

    @Override
    public BulletType bulletType() {
        return BulletType.HEAVY;
    }

    @Override
    public List<Sound> sound() {
        return List.of(Sound.ENTITY_GENERIC_EXPLODE, Sound.ENTITY_FIREWORK_ROCKET_BLAST);
    }

    @Override
    public float soundPitch() {
        return 1f;
    }

    @Override
    public void onHitEntity(Location location, LivingEntity entity) {
        explode(location);
    }

    @Override
    public void onHitBlock(Location location, Block block) {
        explode(location);
    }

    private static void explode(Location location) {
        //location.getWorld().createExplosion(location, 1f, false, false);
        for (Entity entity : location.getWorld().getNearbyEntities(location, 5f, 5f, 5f)) {

            if (entity instanceof LivingEntity livingEntity) {
                Location playerLocation = livingEntity.getLocation();

                // Calculate direction vector (from point to player)
                Vector direction = playerLocation.toVector().subtract(location.toVector());

                // Normalize the vector to keep consistent speed
                direction.normalize().multiply(2); // Change the multiplier for speed adjustments

                // Apply velocity to the player
                livingEntity.setVelocity(livingEntity.getVelocity().add(direction));
            }
        }
        location.getWorld().spawnParticle(Particle.EXPLOSION, location, 10, 0.1f, 0.1f, 0.1f);
    }

    @Override
    public boolean makeBlood() {
        return false;
    }

    @Override
    public double bulletSpeed() {return 4;}

    @Override
    public double damage() {
        return 0;
    }

    @Override
    public int cooldown() {
        return 40;
    }

    @Override
    public int textureId() {
        return 7;
    }

    @Override
    public CraftingRecipe recipe() {
        ShapedRecipe recipe = new ShapedRecipe(NamespacedKey.fromString("giguns:rocketjumper"), compileGun());
        recipe.shape("III","rgT","IIs");
        recipe.setIngredient('T', Material.TNT);
        recipe.setIngredient('I', Material.IRON_BLOCK);
        recipe.setIngredient('r', Material.BREEZE_ROD);
        recipe.setIngredient('s', Material.STICK);
        recipe.setIngredient('g', Material.SLIME_BLOCK);
        return recipe;
    }
}
